# -*- coding: utf-8 -*-
import re
from pprint import pprint

from pyquery import PyQuery as pq


#
# pattern = re.compile(r"\[来源.*?\]|www\..*?com")
#
# filter_words = ["学科网", "高考资源网", "Ziyuanku.com", "WWW.ziyuanku.com",
#                 "高☆考♂资♀源€网", "w.w.w.k.s.5.u.c.o.m", "本资料由《七彩教育网》www.7caiedu.cn 提供!",
#                 "本资料来源于《七彩教育网》http://www.7caiedu.cn", "本资料由《七彩教育网》www.7caiedu.cn 提",
#                 "高考试题来源:"]
#
#
# def filter_word(txt_list):
#     new_txt_list = []
#     for word in txt_list:
#         if not word.strip():
#             continue
#         new_word = re.sub(pattern, "", word)
#         for keys in filter_words:
#             if keys in new_word:
#                 new_word = new_word.replace(keys, "")
#         new_txt_list.append(new_word)
#     return new_txt_list


def filter_data(x):
    if not str(x).replace(" ", "").strip():
        pass
    else:
        return str(x)


def replace_k(con):
    # con = str(con).replace("&nbsp;", "+")
    # con = str(con).replace(" ", "+")
    con = re.sub(r'\s(?!(src="http|_src="http|class="tiankong"|data-num=))', "#+#", str(con))
    return pq(con, parser="html")


def css_label_wash(content):
    # todo add 9-4
    """
    清洗文本中带有的css标签
    :param content:
    :return:
    """
    # temp_con = re.sub('</?p(\s*|\s+style=.*?")?>', "", str(content))
    if re.search('</?(span|font|article|ul|ol|div)(\s*|\s+style=.*?")>|text\s*-\s*decoration: underline|border\s*-\s*bottom:', str(content)) is None:
        # content = re.sub('</p\s*>', "\n", content).strip().replace("\n\n", "\n").replace("\n", "<br/>")
        def subp(s):
            cons = s.group(1)
            if '<p style="text-indent:' in cons or '<p style="text-align:' in cons:
                return cons
            else:
                return "<p>"
        content = re.sub('(<p(\s*|\s+style=.*?")>)', subp, content)
        content = re.sub('</p><p>', "</p>\n<p>", content)
        return content
    else:
        content = re.sub(r'<font\s+style="color: red">', "", str(content))
        content = re.sub(r'<span\s+style="color: red">', "", str(content))
        content = re.sub(r'<span\s+style="color: blue">', "", str(content))
        content = re.sub(r'<font\s+style="color: blue">', "", str(content))
        content = content.replace("</font >", "").replace("</font>", "")
        # content = content.replace("</span >", "").replace("</span>", "")
        content = content.replace('<p style="height: 0;">&nbsp;</p>', "\n").replace('<p><br/></p>', "\n")
        content = content.replace("</p>", "</p>\n")
        # content = re.sub('<p( style=.*?")?>', "", content)
        # content = re.sub('<br\s*/?>', "\n", content)
        # parm = False
        # if "<article>" not in str(content):
        #     parm = True
        subs2img = {}
        if re.search('<img.*? src="', content) or "</table>" in content:
            all_imgs = re.findall('<img.*? src=.*?[\s/"]>|<table.*?>.*?</table>',
                                  content, flags=re.S)
            for k, img in enumerate(all_imgs):
                content = content.replace(img, "&{}&".format(k))
                subs2img["&{}&".format(k)] = img
        content = re.sub(r"<(su[bp])>(.*?)</(su[bp])>", r"【\1】\2【/\3】", content)

        html = pq(content, parser="html")
        a = []

        if html.children():
            for line in html.children().items():  # <p>.*?</p>里面的内容可能会被过滤掉
                test = line.text()
                # 保留下划线及着重符标签   <span style="text-decoration: underline;">
                # 波浪线：<span style="text-decoration: underline wavy;">
                # pq会将多个空格换成一个
                if '<span style="text-decoration: underline' in str(line) or '<span class="dots"' in str(line)\
                        or re.search('<(p|div) style="text-indent:|<(p|div) style="text-align:|<strong>|<em>', str(line)):
                    line = re.sub(r'<span style="text-decoration: underline(.*?">.+?)</span>', r"【1#\1##】", str(line))
                    line = re.sub(r'<span class="dots">(.+?)</span>', r"【2#\1##】", str(line))
                    line = re.sub(r'<(p style="text-(indent|align):.*?">.+?)</p>', r"【\1##3】", str(line))
                    line = re.sub(r'<(div style="text-(indent|align):.*?">.+?)</div>', r"【\1##3】", str(line))
                    # line = re.sub(r'<(strong|em)>(.+?)</\1>', r"【\1##\2##\1】", str(line))
                    # 分开处理会比较好，嵌套的格式也能全处理
                    line = re.sub(r'<strong>(.+?)</strong>', r"【strong##\1##strong】", str(line))
                    line = re.sub(r'<em>(.+?)</em>', r"【em##\1##em】", str(line))
                    # print(line)
                    line = line.replace(" ", "【+】")
                    line = pq(line)
                    new_line = list(map(lambda x: str(x).replace("【1#", '<span style="text-decoration: underline')
                                        .replace("##】", "</span>").replace("【2#", '<span class="dots">')
                                        .replace("【p【+】style=", "<p style=").replace("【div【+】style=", "<p style=")
                                        .replace("##3】", "</p>").replace("【strong##", "<strong>").replace("【em##", "<em>")
                                        .replace("##strong】", "</strong>").replace("##em】", "</em>").replace("【+】", " "),
                                        line.text().split("\n")))
                    a.extend(new_line)
                elif str(line).startswith("<p") and line.text().strip():
                    if '<img src="http://' in str(line) or "text-decoration: underline" in str(line) or "border-bottom:" in str(line) or "text - decoration: underline" in str(line):
                        # a.append(line.html().replace("<br />", "\n").replace("<br/>", "\n").replace("<br>", "\n") + "\n")
                        a.append(line.html())
                    else:
                        line = replace_k(line)
                        if re.search(r"\n|<br\s*/?>", str(line), flags=re.S):
                            line = re.sub(r"\n|<br\s*/?>", "#*#", str(line), flags=re.S)
                            line = pq(line)
                            new_line = list(map(lambda x: str(x).replace("#+#", " "), line.text().split("#*#")))
                            a.extend(new_line)
                        else:
                            if line.text().strip():
                                a.append(line.text().replace("#+#", " "))

                elif "<article>" in str(line) and "</article>" in str(line):
                    line = re.sub(r'<p.*?>', "", str(line.html()))
                    b = line.replace('</p>', ""). \
                        replace("<br>", "\n"). \
                        replace("<br/>", "\n"). \
                        replace("<br />", "\n"). \
                        replace('<p style="height: 0;">&nbsp;</p>', "\n"). \
                        replace('<p style="height: 0;"> </p>', "\n")
                    b_list = b.split("\n")
                    # b_list = list(filter(lambda x: str(x), b_list))
                    b_list = list(filter(filter_data, b_list))
                    b_list = list(map(lambda x: str(x), b_list))
                    a.extend(b_list)

                elif str(line).startswith("<ul"):
                    a.append(line.text())
                elif line.attr("class") == "slave-datas":
                    for j, ss in enumerate(line.children().items()):
                        if ss(".read-list-title").text():
                            a.append(str(j + 1) + "." + ss(".read-list-title").text())
                        if ss(".read-list-opt").text():
                            a.append(ss(".read-list-opt").text().replace("\n", "\t"))
                        if str(ss).startswith("<ul"):
                            a.append(ss.text())
                elif str(line).startswith("<table"):
                    a.append(str(line))
                elif str(line).startswith("<ol"):
                    for i, ss in enumerate(line.children().items()):
                        a.append(str(i + 1) + "." + ss.text())
                else:
                    # print('test:',line.text())  # 自动去掉了图片
                    if line.text().strip():
                        line = replace_k(line)
                        # a.append(line.text().replace("+", "\xa0") + "\n")
                        a.append(line.text().replace("#+#", " "))

        else:
            # if html.text().strip():  把换行\n 都去掉了
            #     a.append(html.text())
            # a.append(str(html)) # 会自动带上</?p> ；&变为&amp；
            a.append(content.strip())

        new_a = "\n".join(list(filter(lambda x: x.strip(), a)))
        if subs2img:
            new_a = re.sub("|".join(subs2img.keys()), lambda x: subs2img[x.group()], new_a)
        # new_a = "<p>" + new_a.replace("\n\n", "\n").replace("\n", "</p>\n<p>") + "</p>"
        new_a = "<p>" + new_a.replace("\n\n", "\n") + "</p>"
        # for sb, img in subs2img.items():  # 2021
        #     new_a = new_a.replace(sb, img)
        # if parm:
        #     new_a[0] = "\xa0" * 4 + new_a[0]
        new_a = re.sub(r"【(/?su[bp])】", r"<\1>", new_a)
        return new_a


def again_parse(content):
    # todo add 9-4
    content = re.sub(r'<font\s+style="color: red">', "", str(content))
    content = re.sub(r'<span\s+style="color: red">', "", str(content))
    content = re.sub(r'<span\s+style="color: blue">', "", str(content))
    content = re.sub(r'<font\s+style="color: blue">', "", str(content))
    content = str(content).replace("</font >", "").replace("</font>", "")
    content = str(content).replace("</span >", "").replace("</span>", "")
    content = str(content).replace('<p style="height: 0;">&nbsp;</p>', "\n").replace('<p><br/></p>', "\n")
    # parm = False
    # if "<article>" not in str(content):
    #     parm = True

    html = pq(content, parser="html")
    a = []
    if html.children():
        for line in html.children().items():

            if (str(line).startswith("<p") and line.text().strip()) or "http://zxhx-1302712961.cos.ap" in str(line):

                if 'http://zsytk2.zhixinhuixue.com/static/images' in str(line) \
                        or "text-decoration: underline" in str(line) \
                        or "border-bottom:" in str(line) \
                        or "text - decoration: underline" in str(line) \
                        or 'http://zxhx-1302712961.cos.ap' in str(line):
                    a.append(line.html().replace("<br />", "\n").replace("<br/>", "\n").replace("<br>", "\n") + "\n")
                else:
                    line = replace_k(line)
                    if "<br>" in str(line) or "<br/>" in str(line) or "<br />" in str(line):
                        line = str(line).replace("<br/>", "###").replace("<br>", "###").replace("<br />", "###")
                        line = pq(line)
                        new_line = list(map(lambda x: str(x).replace("+", "\xa0") + "\n", line.text().split("###")))
                        a.extend(new_line)
                    else:
                        if line.text().strip():
                            a.append(line.text().replace("+", "\xa0") + "\n")

            elif "<article>" in str(line) and "</article>" in str(line):
                line = re.sub(r'<p.*?>', "", str(line.html()))
                b = line.replace('</p>', ""). \
                    replace("<br>", "\n"). \
                    replace("<br/>", "\n"). \
                    replace("<br />", "\n"). \
                    replace('<p style="height: 0;">&nbsp;</p>', "\n"). \
                    replace('<p style="height: 0;"> </p>', "\n")
                b_list = b.split("\n")
                # b_list = list(filter(lambda x: str(x), b_list))
                b_list = list(filter(filter_data, b_list))
                b_list = list(map(lambda x: str(x) + "\n", b_list))
                a.extend(b_list)

            elif str(line).startswith("<ul"):
                a.append(line.text() + "\n")
            elif line.attr("class") == "slave-datas":
                for j, ss in enumerate(line.children().items()):
                    if ss(".read-list-title").text():
                        a.append(str(j + 1) + "." + ss(".read-list-title").text() + "\n")
                    if ss(".read-list-opt").text():
                        a.append(ss(".read-list-opt").text().replace("\n", "\t") + "\n")
                    if str(ss).startswith("<ul"):
                        a.append(ss.text() + "\n")
            elif str(line).startswith("<table"):
                a.append(str(line) + "\n")
            elif str(line).startswith("<ol"):
                for i, ss in enumerate(line.children().items()):
                    a.append(str(i + 1) + "." + ss.text() + "\n")
            else:
                if line.text().strip():
                    line = replace_k(line)
                    a.append(line.text().replace("+", "\xa0") + "\n")
    else:
        if html.text().strip():
            a.append(html.text() + "\n")
    a = "\n".join(a).split("\n")
    new_a = list(filter(lambda x: x.strip(), a))
    # if parm:
    #     new_a[0] = "\xa0" * 4 + new_a[0]
    return new_a


if __name__ == '__main__':
    cons = r'''
       <div class="stem-wraper" data-v-494b33d9=""><span class="stem" data-v-494b33d9="">下述有关功和能量说法正确的是（ ）</span></div>
<ul class="stem-options" data-v-494b33d9="">
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">A.</span><span data-v-494b33d9="">物体做功越多，<span style="text-decoration: underline wavy;">物体的能量就越大</span></span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">B.</span><span data-v-494b33d9="">摩擦力可能对物体做正功，也可能做负功，<span style="text-decoration: underline;">也可以不做功</span></span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">C.</span><span data-v-494b33d9="">能量耗散表明，能量守恒定律有些情况下并不成立</span></li>
<li data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">D.</span><span data-v-494b33d9="">弹簧拉伸时的弹性势能一定大于压缩时的弹性势能</span></li>
</ul>
<div class="topic-analysis" data-v-494b33d9="">
<div class="topic-analysis-content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">【答案】</span><span data-v-494b33d9="">B</span></div>
<div class="topic-analysis-content" data-v-494b33d9=""><span class="analysis-prefix" data-v-494b33d9="">【解析】</span><span data-v-494b33d9="">功是能量转化的量度，物体做功越多，物体的能量转化就越多，而不是能量越大。故A错误；摩擦力方向可能与物体运动方向相同、也与物体运动方向相反，所以摩擦力可能对物体做正功，也可能做负功。物体也可能没有位移，摩擦力不做功，故B正确；能量耗散虽然不会使能的总量减少，但能量的可利用率越来越低，即能量的品质越来越低；根据能量守恒定律可知，虽然能量的可利用率越来越低，但能量总和保持不变，仍然遵守能量守恒定律，故C错误；弹簧的弹性势能与形变量有关，弹簧拉伸时与压缩时弹性势能可能相等，也可能拉伸时的弹性势能小于压缩时的弹性势能。故D错误。故选B。</span></div>
</div>
    '''
#     cons = '''<p style="margin-top:0;margin-right:0;margin-bottom:0;margin-left:0;text-align:justify;text-justify:inter-ideograph;line-height:150%"><span style="line-height: 150%;font-size: 14px">Unbelievable</span><span style=";font-family:宋体;line-height:150%;font-size:14px"><span style="font-family:宋体">！</span></span><span style="line-height: 150%;font-size: 14px">Oh..., _____ you don&#39;t mind, I&#39;ll stop and take a deep breath.</span></p><p><br/></p>
# <p>【答案】<p style="margin-top:0;margin-right:0;margin-bottom:0;margin-left:0;text-align:justify;text-justify:inter-ideograph;line-height:150%"><span style=";font-family:宋体;line-height:150%;font-size:14px">1</span><span style="line-height: 150%;font-size: 14px">.if</span><span style=";font-family:宋体;line-height:150%;font-size:14px"><span style="font-family:宋体">。考查</span></span><span style="line-height: 150%;font-size: 14px">if</span><span style=";font-family:宋体;line-height:150%;font-size:14px"><span style="font-family:宋体">引导的条件状语从句。根据句意可知。</span></span></p><p><br/></p></p>
# <p>【解析】</p>'''

    # pprint(cons)
    # print(again_parse(cons))
    # print(again_parse(cons))
    # print(list(map(lambda x: str(x).replace("     ", " "), again_parse(cons))))
    # con1 = r'<p>解：A．研究跨栏动作时，刘翔的大小和形状不能忽略，不能看作质点，故A错误；<br/>B．选取不同的参考系，物体的运动状态是不相同的，故B错误；<br/>C．出租车收费是按路程收费的，故C错误；<br/>D．第<img src="http://192.168.1.145:10811/static/physical_formulas_imgs/16184553930794225.png" data-latex="${4 \rm{s} }$" width="13",height="11" />是指<img src="http://192.168.1.145:10811/static/physical_formulas_imgs/16184553931930702.png" data-latex="${1 \rm{s} }$" width="12",height="11" />的时间，是指从<img src="http://192.168.1.145:10811/static/physical_formulas_imgs/16184553930220437.png" data-latex="${3 \rm{s} }$" width="13",height="11" />末到<img src="http://192.168.1.145:10811/static/physical_formulas_imgs/16184553930794225.png" data-latex="${4 \rm{s} }$" width="13",height="11" />末这一段时间，故D正确；<br/>故选：D．</p>'

    cons1 = """
    <p>my-tac-f江西省2022年初中学业水平考试my-tac-b</p><p>my-tac-f英语样卷试题卷（六）my-tac-b</p><p>说明：1. 全卷满分120分，考试时间120分钟。</p><p>my-ti-f2. 请将答案写在答题卷上，否则不给分。my-ti-b</p><p>一、听力测试（20 分）</p><p>现在是试听时间。请听一段对话，然后回答问题。</p><p>What is the boy going to buy?</p><p>A. Some juice. </p><p>B. Some oranges. </p><p>C. Some apples. </p><p>答案是C。</p><p>my-ti-fA）请听下面5段对话。每段对话后有一小题，从题中所给的A、B、C三个选项中选出最佳选项，并在答题卷上将该项涂黑。听完每段对话后，你都将有10秒钟的时间回答有关小题和阅读下一小题。每段对话读两遍。（每小题1分）my-ti-b</p><p>1. How will the woman go to Los Angeles?</p><p>A. By car. </p><p>B. By train. </p><p>C. By plane. </p><p>2. When is Jessica's birthday?</p><p>A. On April 1st. </p><p>B. On June 1st. </p><p>C. On June 2nd. </p><p>3. Who lost a bicycle?</p><p>A. Kate. B. John. C. Mary. </p><p>4. Where does the conversation probably take place?</p><p>A. In a classroom. B. At the doctor's. C. In a gym. </p><p>5. What does the man mean?</p><p>A. It's rainy now. B. It's sunny now. C. It's windy now. </p><p>my-ti-fB）请听下面4段对话。每段对话后有几个小题，从题中所给的A、B、C三个选项中选出最佳选项，并在答题卷上将该项涂黑。听每段对话前，你将有时间阅读各个小题，每小题5秒钟；听完后，各小题给出5秒钟的作答时间。每段对话读两遍。（每小题1分）my-ti-b</p><p>请听第1段对话，回答第6、7小题。</p><p>6. Why does Tom want to sell the computer?</p><p>A. Because he needs money. </p><p>B. Because he is a fashion lover. </p><p>C. Because it is not good to use. </p><p>7. Which of the following is true?</p><p>A. Peter will buy a new computer soon. </p><p>B. The computer costs 2,500 dollars. </p><p>C. Peter may borrow money from his parents. </p><p>请听第2段对话，回答第8、9小题。</p><p>8. What does Alex's mother do?</p><p>A. A doctor. </p><p>B. A guard. </p><p>C. A nurse. </p><p>9. What can we know about Alex?</p><p>A. He takes pride in being a doctor. </p><p>B. His mom's job is tiring but great. </p><p>C. He hasn't seen his mom for about one year. </p><p>请听第3段对话，回答第10至第12小题。</p><p>10. Which sport is Alice good at?</p><p>A. High jump. </p><p>B. Swimming. </p><p>C. Running. </p><p>11. What's Bob's favorite sport?</p><p>A. Basketball. </p><p>B. Long jump. </p><p>C. Baseball. </p><p>12. What can we know about Bob and Alice?</p><p>A. Bob won the first prize last year. </p><p>B. Bob is getting ready for the tennis match. </p><p>C. Alice broke the new record in her school. </p><p>请听第4段对话，回答第13至第15小题。</p><p>13. Why was Larry sad?</p><p>A. He made his mom angry. </p><p>B. He did badly in the exam. </p><p>C. He couldn't answer the teacher's questions in class. </p><p>14. What's the relationship between the two speakers?</p><p>A. Headteacher and student. </p><p>B. Brother and sister. </p><p>C. Friends. </p><p>15. What can we learn from the conversation?</p><p>A. Larry and Cindy will study together. </p><p>B. Larry's mom will understand him. </p><p>C. Cindy would help him with physics. </p><p>my-ti-fC）请听下面一段独白，根据独白内容完成下列句子，每个空格不超过3个单词，将答案填写到答题卷的相应位置。听独白前你将有50秒钟的时间阅读句子内容。独白读两遍。（每小题1分）my-ti-b</p><p>16. The best times to visit Sydney are ________________.</p><p>17. The room in an international hotel in the center is about ________________ a night. </p><p>18. There are beaches, walks, parks and the wonderful ________________ in Sydney. </p><p>19. There are many ________________ on Oxford Street for night life. </p><p>20. It is best to go sightseeing in Sydney ________________.</p><p>二、单项选择</p><p>my-ti-f请阅读下面各小题，从题中所给的A、B、C、D四个选项中选出可以填入空白处的最佳选项，并在答题卷上将该项涂黑。（每小题1分）my-ti-b</p><p>1. The doctor told me to eat more _________ because it's good for my health. </p><p>A. orange B. ice-cream C. milk D. fish</p><p>2. —Wow, South Korean film Parasite won the Oscar for Best Picture in 2020. </p><p>—I was really _________ when I heard about it, because it is the first time that an Asian film won the award. </p><p>A. excited B. lucky C. confident D. sure</p><p>3. —It looks like a television. Do you think so?</p><p>—Yes, I _________.</p><p>A. know B. agree C. understand D. mean</p><p>4. —Can I go into the meeting room now?</p><p>—Of course, if you _________.</p><p>A. invite B. are invitingC. have invitedD. were invited</p><p>5. She's brought you some eggs. As you know, she _________ chickens. </p><p>A. keeps B. will keep C. has kept D. is kept</p><p>6. Everybody lent a hand, _________ the work was done on time. </p><p>A. OrB. ifC. soD. as</p><p>7. —Could I have an interview with Mr. Green now, please?</p><p>—Sorry, he _________ a meeting. You'd better wait a minute. </p><p>A. HasB. had C. is having D. was having</p><p>8. If one of your friends sends you a message to borrow money on the Internet, you'd better phone him _________ first to make sure of that. </p><p>A. recently B. directly C. finally D. suddenly</p><p>三、完形填空（26 分）</p><p>my-ti-fA）请先阅读下面短文，掌握其大意，然后从各小题所给的A、B、C、D四个选项中选出可以填入相应空白处的最佳选项，并在答题卷上将该项涂黑。（每小题1分）my-ti-b</p><p>my-ti-fSam was very nervous. It was his first day in a new __9__ and lunch was only thirty minutes away. __10__ most students, lunch is the best part of the school day. It is time when you talk with your friends, get to know what interesting things everyone is doing, and of course __11__ Sam, however, didn't know anyone or anything, like where to sit or __12__ whom to sit at lunch. Sam's __13__ was in the army, so his family moved a lot. He really liked his old school and __14__ leaving his two best friends. They still talked to each other through phone calls and e-mails, but he couldn't see __15__ every day. He wondered if their __16__ would continue. He didn't want to lose them, but he knew it would be __17__ for them to stay close. my-ti-b</p><p>my-ti-f"I know you are nervous," his mother said as he got ready for school this morning, &quot;and I'm really __18__ you have to keep changing schools." Sam could __19__ regret in her eyes, but he didn't want her to feel that way. She had __20__ been ready to defend (保卫) not only the family but also the country. Sam loved her so much. He gave her a smile and told her not to __21__. He had wanted to mean it, but there was still always worry in him when they moved.my-ti-b</p><p>my-ti-fThe __22__ time came quickly. As Sam was walking to the dining room, a voice behind him said, "Excuse me." Sam __23__ and saw five friendly faces.my-ti-b</p><p>my-ti-f"Would you like to join us?" asked one of them.my-ti-b</p><p>my-ti-fThe unexpected invitation was exactly what he needed. Sam nodded yes __24__ and joined them. He was sure about his future school life now.my-ti-b</p><p>9. A. team B. family C. factory D. school</p><p>100. A. For B. With C. About D. From</p><p>11. A. jump B. learn C. eatD. run</p><p>12. A. as B. withC. like D. at</p><p>13. A. brother B. fatherC. motherD. sister</p><p>14. A. hated B. imagined C. tried D. suggested</p><p>15. A. them B. her C. it D. him</p><p>16. A. discussion B. dream C. business D. friendship</p><p>17. A. safe B. hard C. natural D. terrible</p><p>18. A. sorry B. happy C. excited D. bored</p><p>19. A. express B. believe C. smell D. see</p><p>20. A. sometimes B. hardly C. always D. never</p><p>21. A. forget B. move C. return D. worry</p><p>22. A. breakfast B. lunch C. tea as D. dinner</p><p>23. A. turned around B. turned down C. turned off D. turned on</p><p>24. A. bravely B. happilyC. nervously D. patiently </p><p>四、语篇填空</p><p>my-ti-fB）请先阅读下面短文，掌握其大意，然后用方框中所给词的适当形式填空，并将答案填写到答题卷的相应位置。每个词限用一次。（每小题1分）my-ti-b</p><p>【img0】<p> </p><p>my-ti-fWhat kind of homes will we live in twenty or thirty years from now? Some people __25__ that many of us will live in "gated communities" (封闭式社区). There will be high walls around our houses. Security guards (保安) will control the entrances. Inside, there will be __26__, supermarkets, restaurants, hospitals and so on. my-ti-b</p><p>my-ti-fThese gated communities already exist (存在) in many countries. Some of them look like small towns, and they even have __27__ own schools. Of course, they aren't __28__ places to live in: At Beverly Park, in Los Angeles, houses are between twelve and thirty-two million dollars. And some are __29__ more expensive. my-ti-b</p><p>my-ti-fIt's quite clear why people want to live in them. In Johannesburg, South Africa, about sixty-five percent of people __30__ unsafe in their homes at night. In many cities, public spaces like parks are sometimes dangerous. A gated community __31__ people a feeling of security and, naturally, people want to feel safe. my-ti-b</p><p>my-ti-fBut not everyone is happy about the future of gated communities, __32__ some top police officers. They say that the people in the gated communities won't __33__ much with people outside. Also, the gap (差距) __34__ the rich and the poor will increase, and society will become more dangerous. my-ti-b</p><p>四、阅读理解（46 分）</p><p>my-ti-fA）请阅读下面短文，根据短文内容从每小题所给的A、B、C、D四个选项中选出最佳选项， 并在答题卷上将该项涂黑。（每小题2分）my-ti-b</p><p>my-tac-fAmy-tac-b</p><p>my-ti-fNew Term at the Meriden Center my-ti-b</p><p>my-tac-fChinese Language Courses!my-tac-b</p><p>my-ti-fWhy I Learn Chinese?my-ti-b</p><p>my-tac-fA new road to a big worldmy-tac-b</p><p>my-ti-fChinese is the No.1 spoken language in the world! More people are speaking Chinese than English, and the need for business people who know Chinese is my-tul-fskyrocketingmy-tul-b. Another great reason is to give your kids or yourself a seat at the table in a world where China is an important partner. Call us for course listings.my-ti-b</p><p>my-ti-f●Small class: 10 ~ 15 studentsmy-ti-b</p><p>my-ti-f●Professional teachers; rich experience in teaching my-ti-b</p><p>my-ti-f●Self-fit course: Studying at your own pace, slower or faster than a usual course my-ti-b</p><p>my-ti-fOffline courses: my-ti-b</p><p>my-ti-fOn workdays: $ 500 per course each termmy-ti-b</p><p>my-ti-fOn weekends: $ 650 per course each term my-ti-b</p><p>my-ti-fOnline courses: my-ti-b</p><p>my-ti-fOn workdays: $ 350 per course each term my-ti-b</p><p>my-ti-fOn weekends: $ 400 per course each termmy-ti-b</p><p>my-tac-f55 West Main Street, Meriden Townmy-tac-b</p><p>my-tac-fUnderground Line 2 &amp; 8, Bus 515 &amp; 613 at Meridenmy-tac-b</p><p>my-tac-fFree street parking parking availablemy-tac-b</p><p>my-tac-f________________________my-tac-b</p><p>35. What does the underlined word "skyrocketing" probably mean?</p><p>A. Developing fast.</p><p>B. Changing quickly.</p><p>C. Doing well.</p><p>D. Flying high.</p><p>36. Which of the following is true according to the passage?</p><p>A. It's easier to get a seat in a Chinese restaurant.</p><p>B. The courses are designed for Chinese children.</p><p>C. Someone needs to pay 400 dollars for a Tuesday offline course.</p><p>D. The advantage of the course is to choose your own speed to learn.</p><p>37. Which would be the best to put in the blank "_____" in the end of the ad. ?</p><p>A. Selected Books Buy One, Get One Free.</p><p>B. Turn left into Garden Road and drive toward north.</p><p>C. For more information contact Angela at 860-343-5807.</p><p>D. Guest speaker: Ann Bella Room 300 2:00 p. m. July 1st.</p><p>my-tac-fBmy-tac-b</p><p>my-ti-fAnna Du was walking along the beach when she noticed plastics there. She reached down to pick them up, and quickly realized there were many more tiny pieces than she could deal with. It seemed impossible to clean them all up. my-ti-b</p><p>my-ti-fDu, 12 years old at the time, tried to solve the problem. like any good scientist—first by doing a little research. That's how she learned that 8 million tons of plastics end up in the oceans every year. my-ti-b</p><p>my-ti-fThen she got to work building something that could help solve the problem; a remote-operated vehicle (遥控潜水器), or ROV. Her ROV can move through water and find plastics on the ocean floor. my-ti-b</p><p>my-ti-fThe actually cool part of Du's ROV is the detection (探测) system. She uses a camera along with three different kinds of light to find the plastics. She also uses visible (可见的) light to find unnatural colors that might make the plastics stand out. my-ti-b</p><p>my-ti-f"She has a very good engineering sense to break down a problem like this and then go after it, "says engineer Casey Machado. "It sounds simple, but it's a level of thinking that's really amazing. my-ti-b</p><p>my-ti-fDu started attending public events and workshops at a university when she was five years old, and then she picked up the engineering skills necessary to build her ROV. She says actually getting her ROV to move through water well was not easy. She failed many times, but she never gave up trying and testing.my-ti-b</p><p>my-ti-fWhen asked about future plans, she mentions wanting to address the effects of climate (气候) change with ambition (雄心). "I think there are a lot of problems that could be solved with new inventions, " says Du.my-ti-b</p><p>my-ti-fDu thanks her parents, who for years have taken her to student outreach activities, for supporting her interest in science, technology, engineering and math (STEM). She says she has been able to meet students and scientists there.my-ti-b</p><p>my-ti-f"I know I want to be an engineer because I like building things to help solve world problems," says Du. &quot;But I'm not sure what kind of engineer I want to be yet.&quot;my-ti-b</p><p>38. Put the events about Anna in the correct order. </p><p>a. Anna did research. </p><p>b. Anna invented a ROV. </p><p>c. Anna joined in public activities. </p><p>d. Anna learned engineering skills. e. Anna found rubbish on the beach. </p><p>A. c-d-a-e-bB. c-d-e-a-bC. e-a-b-c-dD. e-a-d-c-b</p><p>39. Why does Anna want to be an engineer in the future?</p><p>A. Because she is suitable for this job. </p><p>B. Because she is talented in thinking. </p><p>C. Because her parents encouraged her to do that. </p><p>D. Because she likes to invent things and solve the problems. </p><p>40. Which of the following is true about Anna according to the passage?</p><p>A. Anna will be an environmental engineer in the future. </p><p>B. Anna learned STEM from scientists at the age of five. </p><p>C. Anna wants to work out the effects of climate change. </p><p>D. Anna uses a camera with many lights to find plastics. </p><p>41. What can we know about Anna's personality according to the passage?</p><p>A. Creative, hard-working and ambitious. </p><p>B. Clever, humorous and caring. </p><p>C. Smart, caring and loving. </p><p>D. Responsible, persistent and polite. </p><p>my-tac-fCmy-tac-b</p><p>my-tac-f①_________my-tac-b</p><p>my-ti-f②_________my-ti-b</p><p>my-ti-fStrange things were happening in the countryside of the northeast of Hebei. For three days the water in the village wells rose and fell. The chickens and even the wells rose and tell, rose and fell pigs were too nervous to eat. Mice ran out of the fields looking for places to hide. Fish jumped out of their ponds. At about 3:00 a. m. on July 28,1976, some people saw bright lights in the sky and loud noises could be heard, but the city's one million people were asleep as usual that night. my-ti-b</p><p>my-ti-f③_________my-ti-b</p><p>my-ti-fEleven kilometers directly below the city, one of the most deadly earthquakes of the 20th century had begun, and it is a quake that even caused damage (破坏) in Beijing, which is more than 150 kilometers away. In less than one minute, a large city was destroyed, More than 400,000 people who lived there were killed or injured, and thousands of children were left without parents. About 75% of its factories and buildings and 90% of its homes and hospitals were gone. The railway was full of useless pieces of steel (钢). Tens of thousands of cows would never give milk again. Half a million pigs and millions of chickens were dead. Sand now filled the wells instead of water. People were in shock. Later that afternoon, another big quake shook Tangshan again. Water, food, and electricity were hard to get. People began to wonder how long the disaster (灾难) would last.my-ti-b</p><p>my-ti-f④_________my-ti-b</p><p>my-ti-fSoon after the quakes, the government sent soldiers, doctors and nurses to help to rescue the city, which reached over 250,000 people. Workers built homes for people. Fresh food and water were taken to the city by train, truck and plane. my-tul-fSlowly, the city bmy-tul-bmy-tul-fegan to breathe againmy-tul-b. Tangshan started to get back up on its feet. With strong support from the government and the efforts of the city's people, a new Tangshan was built upon the earthquake ruins. Tangshan has proved to the world that in times of disaster, people must unify and rebuild for a brighter future.my-ti-b</p><p>42. Which description about numbers is correct according to the passage?</p><p>A. About 90% of people were injured or dead.</p><p>B. More than 400,000 people in China came to help.</p><p>C. The quake caused damage more than 150 kilometers away.</p><p>D. More than 250,000 people lost their homes in the earthquake.</p><p>43. What does the writer mean by saying "my-tul-fSlowly, the city began to breathe againmy-tul-bmy-tul-f.my-tul-b"?</p><p>A. Everyone supported and cared about the city.</p><p>B. Tangshan recovered fast with the help of the government.</p><p>C. It was difficult for Tangshan to rebuild their new homes.</p><p>D. Actually the earthquake didn't make people lose confidence.</p><p>44. What would be the best title for each blank in the passage?</p><p>a. Coming to The End.</p><p>b. Strange Happenings.</p><p>c. Rebuilding a New Home.</p><p>d. The Night The Earth Didn't Sleep.</p><p>A. ①-a, ②-b, ③-c, ④-d</p><p>B. ①-d, ②-b, ③-a, ④-c</p><p>C. ①-c, ②-b, ③-a, ④-d</p><p>D. ①-d, ②-a, ③-b, ④-c</p><p>45. What's the purpose of writing the passage?</p><p>A. To explain how to deal with the natural disaster.</p><p>B. To describe a hard time Tangshan's people had.</p><p>C. To praise and encourage the spirit of people in Tangshan in the face of difficulty.</p><p>D. To ask people to balance the relationship between man and nature.</p><p>my-tac-fDmy-tac-b</p><p>my-ti-fIf you were born in the 2000s, you are called the oh-ohs. The 21st century. That would make you young, creative, connected, world-wide, and no doubt smart. Maybe good-looking, too. Right? But what do other people think about your generation?my-ti-b</p><p>my-ti-fSome adults worry that you're more interested in the screen in front of you than the world around you. They think of you as the "face-down generation" because you use your phone so much. They wonder how you will deal with school, friends, and family. Are today's teenagers too busy texting and taking selfies (自拍) to become successful in real life—or "LRL", as you would say?my-ti-b</p><p>my-ti-fOther adults worry that today's youth are spoilt (溺爱) and don't want to face the challenges of adult life. Many children born in the 1990s and 2000s were raised by "helicopter parents". They were always there to guide and help their children with a busy program filled with homework and after-school activities such as dancing, drawing, or sports. With parents who do everything for them, today's youth seem to prefer to live like my-tul-fthatmy-tul-b even when they are in their 20s or 30s. my-ti-b</p><p>my-ti-fDoes the face-down generation need a heads-up? Well, probably not. The fact is that many of today's teenagers are better educated and more creative than past generations. They seem to be willing to become leaders. More young people than ever volunteer to help their communities. There are also brave young people such as Malala Yousafzai, the teenager who won the 2014 Nobel Peace Prize for pushing girls' rights to go to school.my-ti-b</p><p>my-ti-fThings are looking up for the face-down generation. So if you're one of the oh-ohs, remember chances are that you do GR8 (great) and LOL (laugh out loud) .my-ti-b</p><p>46. What does the underlined word "my-tul-fthatmy-tul-b" in Paragraph 3 refer to?</p><p>A. Colorful adult life.</p><p>B. Being independent.</p><p>C. Teenagers' busy school life.</p><p>D. Being looked after by parents.</p><p>47.What's the overall tone (基调) of the passage?</p><p>A. Informative but silly. </p><p>B.Informative but personal.</p><p>C. Scientific but boring. </p><p>D.Scientific and happy.</p><p>48. What can we know from the passage?</p><p>A. The oh-ohs should be hopeful about the future.</p><p>B. The writer was also probably born in the 2000s.</p><p>C. "Helicopter parents" prepare their kids to face the challenges.</p><p>D.The writer answered the question in Paragraph 2 by telling stories.</p><p>49. Which of the following best shows the structure of the passage?</p><p>A. 【img1】   B. 【img2】   </p><p>C. 【img3】   D. 【img4】</p><p>五、阅读还原七选五</p><p>my-ti-fB）请先阅读下面短文，掌握其大意，然后根据短文内容从下面方框内的七个选项中选择五个还原到文中，使短文意思通顺、结构完整，并在答题卷上将其序号涂黑。一空一句。（每小题2分）my-ti-b</p><p>my-ti-fWhat is Britpop? That's a good question. The music is certainly very catchy. You can often recognize a Britpop song as soon as you hear it.Some of the biggest Britpop bands include Oasis, Blur, Suede and Pulp. __50__my-ti-b</p><p>my-ti-fSo how do we recognize the difference between Britpop and regular rock or pop? Well, Britpop mixes a number of different pop and rock styles with interesting lyrics and attitudes. __51__ Britpop is also about fashion, art and politics (政治).my-ti-b</p><p>my-ti-f__52__ Some of them hired famous artists to help them make more creative videos. English artist Damien Hurst, for example, produced some of Blur's music videos.my-ti-b</p><p>my-ti-fAs for politics, former UK Prime Minister Tony Blair has talked about how much he enjoys Britpop. Perhaps he has talked trying to sound cool to win was just trying to sound more votes (投票) from young people.my-ti-b</p><p>my-ti-fBritpop came and went in the 1990s. __53__ Pulp's most famous song is Common People. Blur's Country House is about a wealthy man who lives a boring life in a big house in the countryside. Blur and Oasis were probably the most popular bands.my-ti-b</p><p>my-ti-fHowever, just like many fashion and art trends (潮流), Britpop didn't stick around for long.my-ti-b</p><p>my-ti-f__54__ Fewer songs were produced and most Britpop bands broke up.my-ti-b</p><p>A. But it is not just about the music.</p><p>B. Britpop music has the same theme.</p><p>C. Britpop bands are very popular among young people.</p><p>D. By the end of the 1990s, Britpop was no longer fashionable.</p><p>E. Britpop bands had some popular Britpop songs at the time.</p><p>F. If you watch their music videos, you'll see how fashionable Britpop singers are.</p><p>G. However, bands like Oasis that are considered Britpop have more of a rocky style.</p><p>四、任务型阅读</p><p>C）请阅读下面短文，根据短文内容用英语回答问题。（每小题2分）</p><p>my-ti-fMany Americans have been leaving their cars at home and riding to work on bicycles. Andy Andy Clark is the leader of the League of American Bicyclists.His group supports bicycling for fun, fitness and transportation.my-ti-b</p><p>my-ti-fClark says this is good news for the environment. He says riding a bicycle to work does not burn fossil fuel or create dangerous pollution. Experts say the effects are the most important on short trips. The Department of Transportation says fifty percent of Americans drive eight kilometers or fewer pollution into the air to work. Shorter car trips set out more for each kilometer drive. This is because the car engine will set out the harmful air when it warms up before it can work well.my-ti-b</p><p>my-ti-fJames, a member a member of Congress (国会), is a strong supporter of bicycle use. He says cities, counties, state governments and state highway transportation agencies are planning the roadways of the future. They are creating roads and paths for bicycles in cities and between communities.my-ti-b</p><p>my-ti-fLast year, Portland, the Pacific Northwest city in the state of Oregon. had the highest percentage of bicycle users in the United States. Portland has been doing progressive city planning for many years to create special paths for bike riders.my-ti-b</p><p>55. What does Andy Clark's group support?</p><p>_______________________________________________________________________________</p><p>56. Why is riding a bicycle to work is good for the environment?</p><p>_______________________________________________________________________________</p><p>57. What can we infer from the last two paragraphs?</p><p>_______________________________________________________________________________</p><p>五、补全对话七选五（5分）</p><p>my-ti-f请阅读下面对话，根据对话内容从下面方框内的七个选项中选择五个填入空白处，使对话通顺、合理，意思完整，并在答题卷上将其序号涂黑。一空一句。（每小题1分）my-ti-b</p><p>A: Alice, you look down. </p><p>B: Yes, I had a bad day today.</p><p>A: __58__</p><p>B: My friend Judy invited me to have dinner at a restaurant. But she got late and waiting for her made me very angry.</p><p>A: __59__</p><p>B: I waited for half an hour.</p><p>A: __60__</p><p>B: She said the traffic was terrible.</p><p>A: And then?</p><p>B: As soon as we sat down,she said the music at that restaurant made her sleepy.</p><p>A: __61__</p><p>B: Yes,we did. And we went to another restaurant. But when we got there,the restaurant had been closed.</p><p>A: __62__</p><p>A. That's too bad.</p><p>B. What did you do?</p><p>C. What happened?</p><p>D. Did you leave there?</p><p>E. How long did you wait?</p><p>F. I can't believe what you did. </p><p>G. Why was she late for such a long time?</p><p>六、书面表达（15分）</p><p>my-ti-f假设你是李华，即将初中毕业，你的美国笔友Tom来信询问你的暑假计划，请根据下面图表信息给他写一封回信。my-ti-b</p><p>my-ti-f【img5】my-ti-b</p><p>要求：1. 回信需要包含图表中的所有要点，不要逐字翻译，并作适当补充；</p><p>2.<p>my-ti-f回信不得出现真实的人名、校名等相关信息；my-ti-b</p><p>my-ti-f3. 词数不少于80，开头和结尾已给出，不计入总词数。my-ti-b</p><p>Dear Tom,</p><p>my-ti-fSummer vacation is coming soon.my-ti-b</p><p>_______________________________________________________________________________</p><p>_______________________________________________________________________________</p><p>_______________________________________________________________________________</p><p>my-ti-fHow do you spend your holiday? my-ti-b</p><p>my-ti-fBest wishes.my-ti-b</p><p style="text-align: right">Yours,</p><p style="text-align: right">Li Hua</p><p> </p><p> </p><p> </p><p> </p><p> </p><p>#################################################</p><p>一、听力测试（共20小题，每小题1分）</p><p>1-5 CCBBA 6-10 BCCBA 11-15 BCBCA</p><p>16. spring and autumn 17. $150 (150 dollars)</p><p>18. bridges 19. clubs 20. by boat</p><p> </p><p></p>
    """
    conss = again_parse(cons1)

    print(conss)